
//===================================
// SAWStudio FX API TestPlugIn - DLL
//
// STRUCTURE DECLARATIONS
// EQUATES
// PROCEDURE DECLARATIONS
// GLOBAL VARIABLES
//
// CopyRight 2001 By Bob Lentini
//===================================

//========================
// STRUCTURE DECLARATIONS
//========================

// FX Shared Memory Data Structure
//--------------------------------
typedef struct
    {
    HWND            FX_hWndMain;
    HFONT           FX_IQSSysFont;
    DWORD           FX_VersionNum;

    DWORD           FX_Handler_DWord_Param1;
    DWORD           FX_Handler_DWord_Param2;
    DWORD           FX_Handler_DWord_Param3;
    DWORD           FX_Handler_DWord_Param4;

    int             FX_Handler_Int_Param1;
    int             FX_Handler_Int_Param2;
    int             FX_Handler_Int_Param3;
    int             FX_Handler_Int_Param4;

    LPBYTE          FX_Handler_Ptr_Param1;
    LPBYTE          FX_Handler_Ptr_Param2;
    LPBYTE          FX_Handler_Ptr_Param3;
    LPBYTE          FX_Handler_Ptr_Param4;

    DWORD           FX_Function_DWord_Param1;
    DWORD           FX_Function_DWord_Param2;
    DWORD           FX_Function_DWord_Param3;
    DWORD           FX_Function_DWord_Param4;

    int             FX_Function_Int_Param1;
    int             FX_Function_Int_Param2;
    int             FX_Function_Int_Param3;
    int             FX_Function_Int_Param4;

    LPBYTE          FX_Function_Ptr_Param1;
    LPBYTE          FX_Function_Ptr_Param2;
    LPBYTE          FX_Function_Ptr_Param3;
    LPBYTE          FX_Function_Ptr_Param4;

    DWORD           FX_MultiTrackRtnTrackOffset;
    DWORD           FX_MultiTrackOutTrackOffset;
    DWORD           FX_MultiTrackVideoTrackOffset;
    DWORD           FX_MultiTrackControlTrackOffset;
    DWORD           FX_MultiTrackLastTrackOffset;

    HWND            FX_hWndMultiTrack;
    DWORD           FX_MTSampleRate;
    DWORD           FX_MTResolution;
    DWORD           FX_MTZoomX;
    DWORD           FX_MTZoomY;
    DWORD           FX_MTMarkBegPos;
    DWORD           FX_MTMarkEndPos;

    char            FX_Title[48];
    DWORD           FX_PlugInIndex;
    DWORD           FX_ParamSet;
    DWORD           FX_Track;
    DWORD           FX_BufferRatioIn;
    DWORD           FX_BufferRatioOut;

    DWORD           FX_RequestXtra;
    DWORD           FX_RequestCancel;

    DWORD           FX_ProcessFlag;
    DWORD           FX_BufferByteSize;
    DWORD           FX_BufferChans;
    DWORD           FX_BufferBytesPerSample;
    DWORD           FX_MaxBufferByteSize;

    DWORD           FX_CurProcessPos;
    DWORD           FX_CurSamplePos;
    DWORD           FX_ProcessBegPos;
    DWORD           FX_ProcessEndPos;

    DWORD           FX_CurSmpteHours;
    DWORD           FX_CurSmpteMins;
    DWORD           FX_CurSmpteSecs;
    DWORD           FX_CurSmpteFrames;
    DWORD           FX_CurSmpteSFrames;
    DWORD           FX_CurSmpteStartOffsetHours;
    DWORD           FX_CurSmpteStartOffsetMins;
    DWORD           FX_CurSmpteStartOffsetSecs;
    DWORD           FX_CurSmpteStartOffsetFrames;
    DWORD           FX_CurSmpteStartOffsetSFrames;
    DWORD           FX_CurSmpteFrameCount;
    DWORD           FX_CurSmpteFormat;
    DWORD           FX_CurSmpteMode;

    HWND            FX_hWndSoundFile;
    DWORD           FX_SFSampleRate;
    DWORD           FX_SFResolution;
    DWORD           FX_SFZoomX;
    DWORD           FX_SFZoomY;
    int             FX_SFZoomShiftY;
    DWORD           FX_SFZoomXMagnify;
    DWORD           FX_SFMarkBegPos;
    DWORD           FX_SFMarkEndPos;
    DWORD           FX_SFCursorSamplePos;
    DWORD           FX_SFStartSamplePos;

    DWORD           FX_SFWaveDBScale;
    int             FX_SFWaveCenterLft;
    int             FX_SFWaveCenterRgt;
    int             FX_SFWaveDivider;
    int             FX_SFWaveTop;
    int             FX_SFWaveBot;
    int             FX_SFWaveLft;
    int             FX_SFWaveRgt;
    DWORD           FX_SFWaveOkToDraw;

    DWORD           FX_MTWaveDBScale;
    int             FX_MTWaveCenterLft;
    int             FX_MTWaveCenterRgt;
    int             FX_MTWaveDivider;
    int             FX_MTWaveTop;
    int             FX_MTWaveBot;
    int             FX_MTWaveLft;
    int             FX_MTWaveRgt;
    int             FX_MTZoomShiftY;
    DWORD           FX_MTWaveTrack;
    DWORD           FX_MTCursorSamplePos;
    DWORD           FX_MTStartSamplePos;
    DWORD           FX_MTWaveOkToDraw;

    DWORD           FX_MTAutomationWriteFlag;
    DWORD           FX_XtraFlag2;
    DWORD           FX_XtraFlag3;
    DWORD           FX_XtraFlag4;
    DWORD           FX_XtraFlag5;
    DWORD           FX_XtraFlag6;
    DWORD           FX_XtraFlag7;
    DWORD           FX_XtraFlag8;
    DWORD           FX_XtraFlag9;
    DWORD           FX_XtraFlag10;
    DWORD           FX_XtraFlag11;
    DWORD           FX_XtraFlag12;

    DWORD           FX_CurTempoBeatsPerMin;
    DWORD           FX_CurTempoBeatsPerMeasure;
    DWORD           FX_CurTempoBeatRes;
    DWORD           FX_CurTempoTickRes;

    } IQS_SAWFXDATA;

//===========
// Constants
//===========
#define ALL_FILES                       1
#define PLG_FILE                        2

#define MAX_PARAM_SETS                  16
#define MAX_LIST_CHARS                  16

#define NONE_AVAILABLE                  0xffffffff
#define NO_ASSIGNMENT                   0xffffffff
#define NO_VALUE                        0xffffffff
#define END_OF_LIST                     0xffffffff

#define MAX_METER_INDEXES               512
#define MAX_METER_SEGMENTS              104
#define METER_RESPONSE_FACTOR_SLOW      2
#define METER_RESPONSE_FACTOR_MED       4
#define METER_RESPONSE_FACTOR_FAST      8

// FX Misc Defines
//----------------
#define FX_ALL_PARAM_SETS               0xffffffff
#define FX_ALL_TRACKS                   0xffffffff
#define FX_ALL_CONTROLS                 0xffffffff

#define FX_WINDOW_DATA                  0x00000001
#define FX_SMPTE_DATA                   0x00000002
#define FX_TEMPO_DATA                   0x00000004

// FX Smpte Mode Definitions
//--------------------------
#define SMPTE_NOT_ACTIVE                0
#define SMPTE_GENERATE_ACTIVE           1
#define SMPTE_GENERATE_MTC_ACTIVE       2
#define SMPTE_GENERATE_BOTH_ACTIVE      3
#define SMPTE_TRIGGER_ACTIVE            4
#define SMPTE_TRIGGER_MTC_ACTIVE        5
#define SMPTE_CHASE_TRIGGER_ACTIVE      6
#define SMPTE_CHASE_TRIGGER_MTC_ACTIVE  7

// FX Smpte Format Defines
//------------------------
#define SMPTE_FORMAT_30N                1
#define SMPTE_FORMAT_30D                2
#define SMPTE_FORMAT_2997N              3
#define SMPTE_FORMAT_2997D              4
#define SMPTE_FORMAT_25                 5
#define SMPTE_FORMAT_24                 6
#define SMPTE_FORMAT_UNKNOWN            7

// FX Process Flag Definitions
//----------------------------
#define PROCESS_IDLE                    0
#define REALTIME_PLAYBACK               1
#define BUILD_TO_MIX_FILE               2
#define PROCESS_TO_SOUND_FILE           3
#define BUILD_TO_FX_MODULES             4
#define DATA_PRESCAN                    5

// FX Handler Function ID Definitions
//-----------------------------------
#define FX_SHUTDOWN                     1

#define FX_BEGIN_PROCESS                2
#define FX_END_PROCESS                  3
#define FX_BEGIN_XTRA                   4
#define FX_END_XTRA                     5

#define FX_OPEN_PLUGIN_WINDOW           6
#define FX_CLOSE_PLUGIN_WINDOW          7

#define FX_PATCH_NEW_PARAM_SET          8
#define FX_RESET_PARAM_SET              9
#define FX_RECEIVE_PARAM_SET_DATA       10
#define FX_SEND_PARAM_SET_DATA          11
#define FX_INIT_PARAM_SET_DATA          12

#define FX_CHANGE_MT_RATE               13
#define FX_CHANGE_MT_RES                14
#define FX_CHANGE_MT_ACTIVE_TRACK       15
#define FX_CHANGE_MT_MARKS              16
#define FX_CHANGE_SMPTE_INFO            17
#define FX_CHANGE_TEMPO_INFO            18

#define FX_CLEAR_CHASE_AUTOMATION       100
#define FX_STORE_CHASE_AUTOMATION       101
#define FX_DISPLAY_CHASE_AUTOMATION     102
#define FX_RESYNC_CHASE_AUTOMATION      103
#define FX_CHANGE_PROCESS_AUTOMATION    104
#define FX_DISPLAY_PROCESS_AUTOMATION   105

// FX Execute Function ID Definitions
//-----------------------------------
#define FORCE_FX_PRESCAN_STOP           1
#define FORCE_FX_PRESCAN_CONTINUE       2
#define MARK_MT_BEG                     3
#define MARK_MT_END                     4
#define CLEAR_MT_MARKS                  5
#define SPLIT_KEEP_MTENTRY              6
#define SPLIT_MARK_MTENTRY              7
#define SPLIT_REMOVE_MTENTRY            8
#define SPLIT_DELETE_MTENTRY            9
#define SELECT_MODE_ON                  10
#define SELECT_MODE_OFF                 11
#define EDL_UNDO_OFF                    12
#define EDL_UNDO_ON                     13
#define EDL_SAVE_UNDO                   14
#define EDL_RECALL_UNDO                 15

#define REFRESH_FX_DATA                 16

#define SET_MT_SAMPLE_POS               17
#define SET_MT_SMPTE_FRAME_POS          18

#define START_MT_AUDIO_PLAY             19
#define START_MT_AUDIO_REC              20
#define START_MT_AUDIO_SRP              21
#define STOP_MT_AUDIO                   22

#define SET_EDL_MODIFY_FLAG             23
#define CHANGE_MT_ACTIVE_TRACK          24

#define SET_MAX_READ_AHEAD              25
#define SET_MIN_READ_AHEAD              26
#define REFRESH_HOST_DISPLAY            27

#define SET_SOLO_SWITCH_VALUE           50

#define SEND_TO_AUTOMATION              100

//=====================
// Control Definitions
//=====================

// Options Popup Menu
//-------------------
#define IDM_OPTIONS_LOAD_PRESETS        5000
#define IDM_OPTIONS_SAVE_PRESETS        5002
#define IDM_OPTIONS_ABOUT               5004

// Parameter List Menu
//--------------------
#define IDM_MENULIST_BASE               5100

// Automation Control Id Values
//-----------------------------
#define MAX_AUTO_CONTROLS               8

#define AUTO_BYPASS_SW                  0
#define AUTO_VOL_POT                    1

#define AUTO_VALUE_1                    2
#define AUTO_VALUE_2                    3
#define AUTO_VALUE_3                    4
#define AUTO_VALUE_4                    5
#define AUTO_VALUE_5                    6
#define AUTO_VALUE_6                    7

//======================
// Procedure Prototypes
//======================

// Dll Main
//---------
BOOL            WINAPI      DllMain(HANDLE, DWORD, LPVOID);
                                  
// Direct API Routines
//--------------------
void            __stdcall   FxInit(IQS_SAWFXDATA*);
void            __stdcall   FxMainHandler(DWORD);
void            __stdcall   FxProcessBuffer(DWORD, LPBYTE);
void            __stdcall   FxChangePosition(void);

// Handler API Routines
//---------------------
void            __stdcall   PlugInShutDown(void);

void            __stdcall   PlugInBegProcess(void);
void            __stdcall   PlugInEndProcess(void);

void            __stdcall   PlugInOpenWindow(void);
void            __stdcall   PlugInCloseWindow(void);

void            __stdcall   PlugInPatchNewParamSet(void);
void            __stdcall   PlugInResetParamSet(void);
void            __stdcall   PlugInReceiveParamSetData(void);
void            __stdcall   PlugInSendParamSetData(void);
void            __stdcall   PlugInInitParamSetData(void);

void            __stdcall   PlugInChangeRate(void);
void            __stdcall   PlugInChangeRes(void);
void            __stdcall   PlugInChangeActiveTrack(void);
void            __stdcall   PlugInChangeMTMarks(void);
void            __stdcall   PlugInChangeSmpteInfo(void);
void            __stdcall   PlugInChangeTempoInfo(void);

void            __stdcall   PlugInClearChaseAutomation(void);
void            __stdcall   PlugInStoreChaseAutomation(void);
void            __stdcall   PlugInDisplayChaseAutomation(void);
void            __stdcall   PlugInReSyncChaseAutomation(void);
void            __stdcall   PlugInChangeProcessAutomation(void);
void            __stdcall   PlugInDisplayProcessAutomation(void);

// Internal Support Routines
//--------------------------
void            __stdcall   InitializeProc(void);
void            __stdcall   ShutdownProc(void);

void            __stdcall   InitThreads(void);
void            __stdcall   ShutDownThreads(void);
void            __stdcall   ForceThreadExit(HANDLE, DWORD, PDWORD);
DWORD           WINAPI      FxBackServiceCallback(LPVOID);

void            __stdcall   IQSGetModuleDirectory(LPSTR);
void            __stdcall   ExtractPath(LPSTR);
void            __stdcall   IQSGetCurDirectory(LPSTR);
void            __stdcall   AddBackSlashToPath(LPSTR);

void            __stdcall   CreateAboutWindow(void);
void            __stdcall   PaintAboutWindow(HDC);

LRESULT         CALLBACK    DLLWndMsgProc(HWND, UINT, WPARAM, LPARAM);

int             __stdcall   CheckBoundaries(LPRECT);

BOOL            __stdcall   PickOpenFileName(LPSTR, LPSTR, LPSTR, int, LPSTR);
BOOL            __stdcall   PickSaveFileName(LPSTR, LPSTR, LPSTR, int, LPSTR, DWORD);

void            __stdcall   RefreshBitmap(HDC, LPRECT, HBITMAP);
void            __stdcall   DisplayBitmapBtn(HDC, LPRECT, HBITMAP);

DWORD           __stdcall   ChkVKey(DWORD);
void            __stdcall   IQSMoveWindow(HWND);
void            __stdcall   GradientFillRect(HDC, LPRECT, int, int, int, int);

void            __stdcall   ClearAllMouseMsgs(void);
int             __stdcall   WaitMsecForEvent(int, UINT);

// PlugIn Control Routines
//------------------------
void            __stdcall   CreatePlugInWindow(DWORD, HWND);
void            __stdcall   DestroyPlugInWindow(DWORD);

LRESULT         CALLBACK    DLLWndPlugInProc(HWND, UINT, WPARAM, LPARAM);

void            __stdcall   DisplayPlugInValue(HDC, DWORD, int, DWORD);
void            __stdcall   PresetPlugInBtns(DWORD);

void            __stdcall   CheckPlugInZones(void);
DWORD           __stdcall   CheckPlugInZonesRight(void);

void            __stdcall   DrawVertKnob(HDC, LPRECT, DWORD, DWORD);
void            __stdcall   LockToVertKnob(void);
void            __stdcall   MoveVertKnob(void);
void            __stdcall   SetVertKnobValue(void);
void            __stdcall   SetVertKnobValueDef(void);

void            __stdcall   PlusMinusCheck(void);
void            __stdcall   PlusMinusEnd(void);
void            __stdcall   ActionControlScroll(void);
void            __stdcall   MoveControlScroll(void);
void            __stdcall   ActionControlMenuList(void);
void            __stdcall   ActionSetToDefaultValue(void);
void            __stdcall   ActionUpdateControl(void);

void            __stdcall   CreateOptionsSelectionMenu(void);

void            __stdcall   SendAutomation(DWORD, int, int, int);

void            __stdcall   SavePlugInPreset(void);
void            __stdcall   LoadPlugInPreset(void);

void            __stdcall   InitPlugInVariables(DWORD, DWORD);
void            __stdcall   InitPlugInMeter(DWORD);
void            __stdcall   ResetParamSet(DWORD);

void            __stdcall   DoPlugInProcess16(void);
void            __stdcall   DoPlugInProcess32(void);

void            __stdcall   ResetMeterDisplay(DWORD);
void            __stdcall   DisplayAllMeters(void);

//==================
// Global Variables
//==================

// General Variables
//------------------
char                        szFxTitle[] = "FX API TestPlugIn";
IQS_SAWFXDATA*              FxPtrSawData = NULL;

DWORD                       FxProgramVersion = 0;
DWORD                       FxPlugInIndex = 0;
DWORD                       FxMaxBufferSize = 0;

DWORD                       FxSampleRate;
DWORD                       FxResolution;

DWORD                       FxReturnTrkOffset;
DWORD                       FxOutputTrkOffset;

DWORD                       FxProcessFlag = 0;
DWORD                       FxPreScanFlag = 0;

DWORD                       FxProcessParamSet = 0;
DWORD                       FxProcessBytesPerSample = 4;
LPBYTE                      FxProcessBuffPtr;
DWORD                       FxProcessBuffSize;
DWORD                       FxProcessPos;

DWORD                       FxSamplePos;

DWORD                       FxActiveParamSet = 0;

HINSTANCE                   hInstFx;
HWND                        hWndSawMain;
HFONT                       hIQSSysFont;

int                         ScreenMaxH;
int                         ScreenMaxV;
int                         CurMouseX = 0;
int                         CurMouseY = 0;
int                         OldMouseX = 0;
int                         OldMouseY = 0;

char                        szWorkBuff[512];
char                        szStringBuff[512];

DWORD                       MemoryAllocFailureFlag = 0;
DWORD                       BuffWorkSize = 0x00020000;
LPBYTE                      PtrBuffWork1;

// File Variables
//---------------
OFSTRUCT                    ofFileStructure;
OPENFILENAME                ofFileName;

char                        szOrgPath[MAX_PATH];
char                        szOpenName[MAX_PATH];
char                        szSaveName[MAX_PATH];
char                        szWork1Name[MAX_PATH];
char                        szDefaultPath[MAX_PATH];

char                        szAllFilters[] = "All Files  *.*\0*.*\0"
                                             "PlugIn Preset File  *.plg\0*.plg\0"
                                             "\0";
                                
char                        szAllQual[] = ".*";
char                        szPlgQual[] = ".plg";

char                        szAppendExt[] = "\0\0\0\0\0\0";

char                        LastPlugInFileName[256];

// Knob Variables
//---------------
DWORD                       VertKnobActive = 0;
DWORD                       VertKnobCtrlId = NO_VALUE;
int                         VertKnobPos = 0;
int                         VertKnobPosDef = 0;
HWND                        VertKnobWindow;
HPEN                        VertKnobPen = 0;
HBITMAP                     VertKnobBackBitmap;
RECT                        VertKnobRect;

// Special Cursors
//----------------
HCURSOR                     hPlusMinusCursor = 0;
char                        szPlugInPlusMinusCursorName[] = "Plus_Minus_Cursor";

// Action Control Variables
//-------------------------
PROC                        ActionControlFunction;

int                         PlusMinusActive = 0;
int                         PlusMinusCenter = 0;

DWORD                       ActiveControlType;
int                         ActiveControlValue;
int                         ActiveControlValueMin;
int                         ActiveControlValueMax;
int                         ActiveControlValueDef;
int                         ActiveControlMultiplier;
RECT                        ActiveControlRect;
LPSTR                       ActiveControlListPtr;

// Communications Messages To SAW
//-------------------------------
char                        szSawFxExecuteFunctionMsg[] = "SawFxExecuteFunction";
DWORD                       SawFxExecuteFunctionMsg = 0;

// Class Names
//------------
char                        szPlugInClass[] = "FX_PLUGIN";
char                        szMsgClass[] = "FX_PLUGIN_MSG";

// Bitmaps
//--------
char                        szPlugInMainName[] = "PlugIn_Main_Bit";
char                        szPlugInBypassBtnName[] = "PlugIn_Bypass_Btn_Bit";
char                        szPlugInMeterName[] = "PlugIn_Meter_Bit";

HBITMAP                     hAboutBitmap = 0;
BITMAP                      AboutBitMapHdr;

HBITMAP                     hPlugInMainBitmap = 0;
BITMAP                      PlugInMainBitmapHdr;

HBITMAP                     hPlugInBypassBtnBitmap = 0;
BITMAP                      PlugInBypassBtnBitmapHdr;

HBITMAP                     hPlugInMeterBitmap = 0;
BITMAP                      PlugInMeterBitmapHdr;

// Drawing Tools
//--------------
HBRUSH                      hBlackBrush;
HBRUSH                      hGrayBrush;

HPEN                        hVertKnobPen;

COLORREF                    hBlackColor;
COLORREF                    hTextColor;

// Selection Menus
//----------------
HMENU                       hMenuOptions;
HMENU                       hMenuList;

// About Message Window
//---------------------
HWND                        hWndAbout = 0;
DWORD                       AboutModalFlag = 0;

// Thread Variables
//-----------------
HANDLE                      hFxBackThread;
DWORD                       FxBackThreadID;
DWORD                       FxBackThreadExitFlag = 0;
DWORD                       FxBackThreadSuspendFlag = 0;
DWORD                       FxBackThreadSleepTime = 80;

// PlugIn Window
//--------------
HWND                        hWndPlugIn[MAX_PARAM_SETS];
HDC                         PlugInDC[MAX_PARAM_SETS];
     
int                         PlugInXStart[MAX_PARAM_SETS];
int                         PlugInYStart[MAX_PARAM_SETS];
int                         PlugInWidth[MAX_PARAM_SETS];
int                         PlugInHeight[MAX_PARAM_SETS];

DWORD                       PlugInBytesPerSample[MAX_PARAM_SETS];
DWORD                       PlugInTrack[MAX_PARAM_SETS];

DWORD                       PlugInParamSetCount;
DWORD                       PlugInParamSetTable[MAX_PARAM_SETS];

DWORD                       PlugInMeterIndexHead[MAX_PARAM_SETS];
DWORD                       PlugInMeterIndexTail[MAX_PARAM_SETS];

int                         PlugInMeterLastValueL[MAX_PARAM_SETS];
int                         PlugInMeterLastValueR[MAX_PARAM_SETS];

DWORD                       PlugInMeterPos[MAX_PARAM_SETS][MAX_METER_INDEXES];
int                         PlugInMeterValueL[MAX_PARAM_SETS][MAX_METER_INDEXES];
int                         PlugInMeterValueR[MAX_PARAM_SETS][MAX_METER_INDEXES];

// Meter Factor Table
//-------------------
int                         MeterTable[MAX_METER_SEGMENTS] = {
                            // Mute
                            //-----
                            0, 8747, 10194, 11642, 13090,
                            14538, 15986, 17434, 20321, 23206,
                            26091, 28976, 31861, 34746, 40499,
                            46249, 51999, 57749, 63499, 69249,
                            80708, 92169, 103630, 115091, 126552,
                            138013, 159475, 180936, 202397, 223858,
                            245319, 266780, 310932, 355084, 399236,
                            443388, 487540, 531692, 619688, 707683,
                            795678, 883673, 971668, 1059663, 1098594,
                            1137521, 1176448, 1215375, 1254302, 1293229,

                            // -16db
                            //------
                            1332156, 1384147, 1436130, 1488113, 1540096,
                            1592079, 1644062, 1696045, 1748028, 1800011,
                            1851994, 1903977, 1955960, 2007943, 2059926,
                            2111909, 2193939, 2275963, 2357987, 2440011,
                            2522035, 2604059, 2686083, 2768107, 2850131,
                            2932155, 3014179, 3096203, 3178227, 3260251,
                            
                            // -8db
                            //-----
                            3342275, 3486735, 3631195, 3775655, 3920115,
                            4064575, 4209035, 4454895, 4700752, 4946609,
                            5192466, 5438323, 5684180, 5930037, 6175894,
                            6421751, 6667608, 6913465, 7159322, 7405179,
                            7651036, 7896893, 8142750, 8388607,
                            };

char                        PlugInParamLabel[6][MAX_LIST_CHARS] =
                            {
                            "Output Format",
                            "Meter Response",
                            "Parameter 3",
                            "Parameter 4",
                            "Parameter 5",
                            "Parameter 6",
                            };                            

char                        OutputFormatTable[6][MAX_LIST_CHARS] =
                            {
                            "Stereo",
                            "Mono",
                            "Lft Only",
                            "Rgt Only",
                            "Lft Mono",
                            "Rgt Mono",
                            };

char                        MeterResponseTable[3][MAX_LIST_CHARS] =
                            {
                            "Slow",
                            "Med",
                            "Fast",
                            };

int                         MeterResponseValue[3] =
                            {
                            METER_RESPONSE_FACTOR_SLOW,
                            METER_RESPONSE_FACTOR_MED,
                            METER_RESPONSE_FACTOR_FAST,
                            };

RECT                        RectPlugInOptions = {339, 83, 391, 110};
RECT                        RectPlugInCloseBtn = {369, 11, 393, 20};
RECT                        RectPlugInBypassBtn = {342, 36, 385, 58};
RECT                        RectPlugInBypassDisplayBtn = {342, 36, 393, 64};
RECT                        RectPlugInTrack = {335, 167, 391, 187};

RECT                        RectPlugInVolPot = {294, 40, 306, 150};

RECT                        RectPlugInValue1 = {13, 12, 101, 33};
RECT                        RectPlugInValue2 = {13, 42, 101, 63};
RECT                        RectPlugInValue3 = {13, 73, 101, 94};
RECT                        RectPlugInValue4 = {13, 104, 101, 125};
RECT                        RectPlugInValue5 = {13, 135, 101, 156};
RECT                        RectPlugInValue6 = {13, 166, 101, 187};

RECT                        RectPlugInLabel1 = {113, 13, 260, 33};
RECT                        RectPlugInLabel2 = {113, 43, 260, 63};
RECT                        RectPlugInLabel3 = {113, 74, 260, 94};
RECT                        RectPlugInLabel4 = {113, 104, 260, 125};
RECT                        RectPlugInLabel5 = {113, 136, 260, 156};
RECT                        RectPlugInLabel6 = {113, 167, 260, 187};

RECT                        RectPlugInMeterL = {314, 49, 315, 152};
RECT                        RectPlugInMeterR = {317, 49, 318, 152};
RECT                        RectPlugInMeterPeakL = {314, 37, 315, 45};
RECT                        RectPlugInMeterPeakR = {317, 37, 318, 45};

// Data Storage Arrays
//--------------------
int                         PlugInDataValue[MAX_PARAM_SETS][MAX_AUTO_CONTROLS];
int                         PlugInDefaultDataValue[MAX_PARAM_SETS][MAX_AUTO_CONTROLS];
int                         PlugInAutoDataValue[MAX_PARAM_SETS][MAX_AUTO_CONTROLS];

// Parameter Set Special Variables
//--------------------------------
int                         FxVolFactor[MAX_PARAM_SETS];
DWORD                       FxOutputFormat[MAX_PARAM_SETS];
int                         PlugInMeterDecayFactor[MAX_PARAM_SETS];

// Text Message String Variables
//------------------------------
char                        AboutMsg[] =                    "Studio Fx API TestPlugIn\n"
                                                            "Version 1.0\n"
                                                            "From\n"
                                                            "Innovative Quality Software\n\n"
                                                            "(c) Copyright 2001 - Bob Lentini\n";

char                        WarningMsg[] =                  "WARNING!";
char                        ImproperPresetMsg[] =           "Improper Preset Format!";
char                        CorruptedErrorMsg[] =           "Corrupted Data Settings For This PlugIn\nPlease Reset Parameters!";

char                        MaximumAssignmentMsg[] =        "This Effect Has Reached Its Maximum Assignments!";

//----
